package net.sourceforge.jFuzzyLogic;

public class Zzz {

	/**
	 * Round a double to an integer (time 100)
	 * @param d
	 * @return
	 */
	static int doubleToInt100(double d) {
		return ((int) Math.round(d * 100));
	}

	static double int100ToDOuble(int i) {
		return (i) / 100.0;
	}

	public static void main(String args[]) throws Exception {
		System.out.println("Begin: Zzz");

		// Load system
		String fileName = "/root/z.fcl";
		FIS fis = FIS.load(fileName, true);

		System.out.println(fis);

		if( true ) {
			// Create a plot
			// JDialogFis jdf = new JDialogFis(fis, 800, 600);
			fis.getVariable("inVar").chart(true);

			// fis.chart();

			// Loop & Delay
			for( int i = 0; i < 100; i++ ) {
				Gpr.debug(i);
				Thread.sleep(500);
			}
		}

		System.out.println("End: Zzz");
	}

	/**
	 * Show values for 'inVar' (membership for sets 'poor', 'good' and 'excellent')
	 *  
	 * @param fclFile
	 * @param evaluate
	 */
	public static void showMembershipTable(FIS fis, boolean evaluate) {
		System.out.println(fis);

		System.out.println(fis.getVariable("inVar"));

		int MAX = 100;
		// Generate table
		System.out.println("inVar\tpoor\tgood\texcellent");
		double var = 0.1;
		for( int count = 0; count < MAX; count++, var += .1 ) {
			double inVar = int100ToDOuble(doubleToInt100(var));
			fis.setVariable("inVar", inVar);

			int poor = doubleToInt100(fis.getVariable("inVar").getMembership("poor"));
			int good = doubleToInt100(fis.getVariable("inVar").getMembership("good"));
			int excellent = doubleToInt100(fis.getVariable("inVar").getMembership("excellent"));

			if( evaluate ) {
				// Evaluate & get output variable
				fis.evaluate();
				double outVar = fis.getVariable("outVar").getLatestDefuzzifiedValue();
				System.out.println(doubleToInt100(inVar) + "\t" + poor + "\t" + good + "\t" + excellent + "\t" + doubleToInt100(outVar));
			} else System.out.println(doubleToInt100(inVar) + "\t" + poor + "\t" + good + "\t" + excellent);
		}
	}

	/**
	 * Show values for 'inVar' (membership for sets 'poor', 'good' and 'excellent')
	 *  
	 * @param fclFile
	 * @param evaluate
	 */
	public static void showMembershipTable(String fclFile, boolean evaluate) {
		FIS fis = FIS.load(fclFile, true);
		showMembershipTable(fis, evaluate);
	}
}
