package net.sourceforge.jFuzzyLogic.demo.invertedPendulum.generic;

import java.io.InputStream;
import java.util.Iterator;
import net.sourceforge.jFuzzyLogic.FunctionBlock;
import net.sourceforge.jFuzzyLogic.demo.invertedPendulum.FuzzyController;
import net.sourceforge.jFuzzyLogic.rule.Variable;

/**
 *
 * @author pjl
 */
public class GenericFuzzyController extends FuzzyController {

//    private Variable x;
//    private Variable dxdt;
//    private Variable force;
    private FunctionBlock functionBlock;
    private double targetX = 0.0;

    public GenericFuzzyController(GenericModel model, InputStream file) {
        super(file, model);
    }

    protected void init() {
        if (fis == null) {
            return;
        }
        functionBlock = fis.getFunctionBlock(null);
        variables.clear();

        FunctionBlock block = fis.getFunctionBlock(null);
        Iterator<Variable> iter = block.variablesIterator();

        while (iter.hasNext()) {
            Variable x=iter.next();
            variables.add(x);
        }
        ((GenericModel)model).setVariables(variables);
    }

    public void control() {
        
        if (functionBlock == null) {
            return;
        }
             
    
        GenericModel bmodel=(GenericModel)this.model;
        
    
        functionBlock.evaluate();

    }

    @Override
    public String showState() {
        return "HELLO IMPLEMENT ME";
        
    }

}
